﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace pr262_1
{
    // Обобщенный делегат: 
    delegate X GenMeth<X,Y>(Y arg);
    // Класс: 
    class MyClass {
        // Целочисленное поле: 
        public int code;
        // Метод с символьным аргументом возвращает символьный 
        // результат:
        public char getChar(char start) {
            return (char)(start + code);
        }
    }

    // Главный класс: 
    class Program
    {
        // Статический метод с целочисленным аргументом 
        // возвращает текстовый результат: 
        static string getStr(int num) { 
            return "Число " + num;
        }
        // Статический метод с текстовым аргументом возвращает 
        // целочисленный результат: 
        static int getInt(string txt) { 
            return Int32.Parse(txt);
        }
        // Главный метод: 
        static void Main()
        {
            // Объект класса:
            MyClass obj = new MyClass(); 
            obj.code = 5;
            // Экземпляры обобщенного делегата:
            GenMeth<string, int> A = getStr;
            GenMeth<int, string> B = new GenMeth<int, string>(getInt);
            GenMeth<char, char> C = obj.getChar;
            // Вызов экземпляров делегата:
            Console.WriteLine(A(123));
            Console.WriteLine(B("100") + 200);
            Console.WriteLine(C('A'));
            // Задержка:
            Console.ReadLine();
        }
    }
}
